package com.company.fpivot.entity;

import com.haulmont.chile.core.annotations.MetaProperty;
import com.haulmont.chile.core.annotations.NamePattern;
import com.haulmont.cuba.core.entity.StandardEntity;

import javax.annotation.Nullable;
import javax.persistence.*;
import java.util.Calendar;
import java.util.Date;

@Table(name = "FPIVOT_INSTITUTE")
@Entity(name = "fpivot_Institute")
@NamePattern("%s|name")
public class Student extends StandardEntity {
    private static final long serialVersionUID = -6340530561987569102L;

    @Column(name = "NAME")
    private String name;

    @Column(name = "DEPARTMENT")
    private String department;

    @Column(name = "INSTITUTE")
    private String institute;

    @Temporal(TemporalType.DATE)
    @Column(name = "BIRTH_DATE")
    private Date birthDate;

    @Transient
    @MetaProperty
    private Integer birthDateMonth;

    public Date getBirthDate() {
        return birthDate;
    }

    public void setBirthDate(Date birthDate) {
        this.birthDate = birthDate;
    }

    public String getInstitute() {
        return institute;
    }

    public void setInstitute(String institute) {
        this.institute = institute;
    }

    public String getDepartment() {
        return department;
    }

    public void setDepartment(String department) {
        this.department = department;
    }

    public String getName() {
        return name;
    }

    public void setName(String name) {
        this.name = name;
    }

    public BirthDateMonth getBirthDateMonth() {
        return BirthDateMonth.fromId(birthDateMonth);
    }
    public void setBirthDateMonth(@Nullable BirthDateMonth birthDateMonth) {
        this.birthDateMonth = birthDateMonth == null ? null : birthDateMonth.getId();
    }

    @PostLoad
    public void postLoad() {
        Date date = getBirthDate();
        if (date != null) {
            Calendar calendar = Calendar.getInstance();
            calendar.setTime(date);
            int studentMonth = calendar.get(Calendar.MONTH);
            int diff = Calendar.getInstance().get(Calendar.MONTH) - studentMonth;

            setBirthDateMonth(BirthDateMonth.fromId(diff));
        }
    }
}